package nc.impl.mc;

import org.jeecg.common.util.HttpHelper;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.NCLocator;
import nc.itf.gl.voucher.IVoucher;
import nc.itf.mc.IEteamsService;
import nc.vo.gl.pubvoucher.VoucherVO;
import u8c.log.NcLog;

public class EteamsServiceImpl implements IEteamsService{
	private IVoucher cher = NCLocator.getInstance().lookup(IVoucher.class); 
	//ȡcodeϢurl
	private static String codeurl = "https://api.eteams.cn/oauth2/authorize";
	private static String corpid = "?corpid=b716cad73e783c17217426cb944fb33e";
	private static String response_type = "&response_type=code";
	private static String state = "&state=As";
	//ȡaccessTokenϢurl
	private static String tokenurl = "https://api.eteams.cn/oauth2/access_token";
	private static String app_key = "?app_key=577aff82e4ca29a51441e26ac8fa7352";
	private static String app_secret = "&app_secret=e977f407cc82fe7b6623285b72792fc7";
	private static String grant_type = "&grant_type=authorization_code";
	//̱IDȡ˵ȫµ
	private static String allidurl = "https://api.eteams.cn/workflow/v2/getAllById";
	//ûid
	private static String userid = "&userid=2150608061134965656";
	
	//IDѯ
	private static String infourl ="https://api.eteams.cn/workflow/v2/getInfoByID";
	
	@Override
	public String getCode() throws Exception {
		//ȡcode
		JSONObject data = JSONObject.parseObject(HttpHelper.doGet(codeurl+corpid+response_type+state, null));
		NcLog.info("CodeJOSN:"+data);
		if("0".equals(data.getString("errcode"))) {
			return data.getString("code");
		}else {
			throw new Exception("Codeȡʧ:"+data.getString("errmsg"));
		}
	}


	@Override
	public String getToken(String code) throws Exception {
		//ȡtoken
		JSONObject data = JSONObject.parseObject(HttpHelper.doPost(tokenurl+app_key+app_secret+grant_type+"&code="+code, null));
		NcLog.info("TokenJOSN:"+data);
		if("0".equals(data.getString("errcode"))) {
			return "?access_token="+data.getString("acessToken");
		}else {
			throw new Exception("Tokenȡʧ:"+data.getString("errmsg"));
		}
	}


	@Override
	public JSONArray getAllId(String id,String token) throws Exception {
		JSONObject data = JSONObject.parseObject(HttpHelper.doGet(allidurl+token+userid+id, null));
		NcLog.info("ݷJOSN:"+data);
		if("0".equals(data.getJSONObject("message").getString("errcode"))) {
			return JSONArray.parseArray(data.getString("requests"));
		}else {
			throw new Exception("ݻȡʧ"+data.getJSONObject("message").getString("errmsg"));
		}
	}


	@Override
	public JSONObject getInfoByID(String token, String id) throws Exception {
		JSONObject data = JSONObject.parseObject(HttpHelper.doGet(infourl+token+userid+id, null));
		NcLog.info("鷵JOSN:"+data);
		if("0".equals(data.getJSONObject("message").getString("errcode"))) {
			return data;
		}else {
			throw new Exception("ȡʧ"+data.getJSONObject("message").getString("errmsg"));
		}
	}


	@Override
	public void saveVoucher_RequiresNew(VoucherVO newvo) throws Exception {
		cher.save(newvo, true);	
	}

}
