package org.jeecg.common.util;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.MapListProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.vo.bd.b04.DeptdocVO;

public class GetDataUtil {

	private static IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	
	public static String getVoucherType(String vouchtypename) throws Exception {
		String sql = "select pk_vouchertype from bd_vouchertype where vouchtypename = '"+vouchtypename+"' and sealflag is null";
		String pk_vouchertype = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if(pk_vouchertype == null) {
			throw new Exception("ƾ֤"+vouchtypename+"δ鵽");
		}
		return pk_vouchertype;
	}
	
	
    //˾
    public static String getCorpPK(String code) throws Exception {
    	String sql = "select pk_corp from bd_corp where unitcode = '"+code+"' and dr = 0";
    	String pk_corp = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_corp == null) {
    		throw new Exception("˾"+code+"δ鵽");
        }
        return pk_corp;
    }
    //Ŀ
    public static String getAccSubject(String code,String pk_glorgbook)throws Exception {
    	String sql = "select pk_accsubj from bd_accsubj where  subjcode = '"+code+"' and (dr is null or dr = 0) and pk_glorgbook='"+pk_glorgbook+"'";
    	String pk_accsubj = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_accsubj == null) {
    		throw new Exception("Ŀ"+code+"δ鵽");
        }
        return pk_accsubj;
    }
    
    //ѯ
    public static DeptdocVO getDept(String name,String pk_corp)throws Exception {
    	String sql = "select pk_deptdoc,deptname from bd_deptdoc where deptname = '"+name+"' and pk_corp = '"+pk_corp+"' and dr = 0";
    	DeptdocVO deptdocVO = (DeptdocVO) iuap.executeQuery(sql, new BeanProcessor(DeptdocVO.class));
    	if (deptdocVO == null) {
    		throw new Exception(""+name+"δ鵽");
        }
        return deptdocVO;
    }
    
    //ѯĺ
    public static String getBdpkByBdInfo(String name)throws Exception {
    	String sql = "select pk_bdinfo from bd_bdinfo where bdname = '"+name+"' and dr = 0";
    	String pk_bdinfo = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_bdinfo == null) {
    		throw new Exception("ĺ"+name+"δ鵽");
        }
        return pk_bdinfo;
    }
    
    //ѯ
    public static String getCurrType(String code)throws Exception {
    	String sql = "select pk_currtype from bd_currtype where currtypecode = '"+code+"' and dr = 0";
    	String pk_currtype = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_currtype == null) {
    		throw new Exception(""+code+"δ鵽");
        }
        return pk_currtype;
    }
	// û
    public static String getUserid(String usercode) throws Exception {
        String sql = "select cuserid from sm_user where user_code ='"+usercode+"' and isnull(dr,0) = 0";
        String cuserid = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (cuserid == null) {
        	throw new Exception("û"+usercode+"δ鵽");
        }
        return cuserid;
    }
    
    //ѯ
    public static String getGlorg(String code)throws Exception {
    	String sql = "select pk_glorg from bd_glorg where glorgcode ='"+code+"' and dr = 0";
    	String pk_glorg = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_glorg == null) {
    		throw new Exception(""+code+"δ鵽");
        }
        return pk_glorg;
    }
    
    //ѯ˱
    public static String getGlorgbook(String pk_glorg)throws Exception {
    	String sql = "select pk_glorgbook from bd_glorgbook where pk_glorg = '"+pk_glorg+"' and dr = 0";
    	String pk_glorgbook = (String) iuap.executeQuery(sql, new ColumnProcessor());
    	if (pk_glorgbook == null) {
    		throw new Exception("˱"+pk_glorg+"δ鵽");
        }
        return pk_glorgbook;
    }
    //ѯƾ֤
    public static Map<String,String> getVoucher(List<String> serNums)throws Exception {
    	StringBuffer sql = new StringBuffer();
    	sql.append("select Free2 from gl_voucher where Free2 in (");
    	for (int i = 0; i < serNums.size(); i++) {
    		sql.append("'"+serNums.get(i)+"',");
		}
    	//ɾһ
    	sql.deleteCharAt(sql.length() - 1);
    	sql.append(")");
    	List<String> list = (List<String>) iuap.executeQuery(sql.toString(), new ColumnListProcessor());
    	Map<String,String> map = new HashMap<String,String>();
    	for (int i = 0; i < list.size(); i++) {
    		String vaule = list.get(i);
    		map.put(vaule, vaule);
		}
		return map;
    	
    }
    
}
