package org.jeecg.common.util;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;


/**
 * @author fenghaifu
 * @version V1.0
 * @Copyright: Ϻ͵ϢƼ޹˾. All rights reserved.
 * @Title:HttpHelper
 * @projectName data-exchange-platform
 * @Description:ͨhttp
 * @date: 2020/1/11 15:16
 * @updatehistory: 2020/1/11 15:16 
 */
public class HttpHelper {	
	
	 /**
     * Http post
     * @param httpUrl 
     * @param param 
     * @return
	 * @throws Exception 
     */
    public static String doPost(String httpUrl,  String param) throws Exception {
        StringBuffer result = new StringBuffer();
        //
        HttpURLConnection connection = null;
        OutputStream os = null;
        InputStream is = null;
        BufferedReader br = null;
      //Ӷ
        URL url = new URL(httpUrl);
        //
        connection = (HttpURLConnection) url.openConnection();
        //󷽷
        connection.setRequestMethod("POST");
        //ӳʱʱ
        connection.setConnectTimeout(10000);
        //öȡʱʱ
        connection.setReadTimeout(10000);
        //DoOutputǷhttpUrlConnectionDoInputǷhttpUrlConnection룬ⷢpost
        //Ƿɶȡ
        connection.setDoOutput(true);
        connection.setDoInput(true);
        //ͨõ
        connection.setRequestProperty("accept", "*/*");
        connection.setRequestProperty("connection", "Keep-Alive");
        connection.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
       /// connection.setRequestProperty("Content-Type", "application/json;charset=utf-8");
        connection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
        //ƴװ
        if (null != param && !param.equals("")) {
            //ò
            os = connection.getOutputStream();
            //ƴװ
            os.write(param.getBytes("UTF-8"));
        }
        //Ȩ
        //ͷ
        //
        //connection.connect();
        //ȡӦ
        if (connection.getResponseCode() == 200) {
            is = connection.getInputStream();
            if (null != is) {
                br = new BufferedReader(new InputStreamReader(is, "UTF-8"));
                String temp = null;
                while (null != (temp = br.readLine())) {
                    result.append(temp);
                    result.append("\r\n");
                }
            }
        }
        //ر
        connection.disconnect();
        return result.toString();
    }
    
    /**
     * Http get
     * @param httpUrl 
     * @param param 
     * @return
	 * @throws Exception 
     */
    public static String doGet(String httpUrl,  String param) throws Exception {
        StringBuffer result = new StringBuffer();
        //
        HttpURLConnection connection = null;
        OutputStream os = null;
        InputStream is = null;
        BufferedReader br = null;
      //Ӷ
        URL url = new URL(httpUrl);
        //
        connection = (HttpURLConnection) url.openConnection();
        //󷽷
        connection.setRequestMethod("GET");
        //ӳʱʱ
        connection.setConnectTimeout(10000);
        //öȡʱʱ
        connection.setReadTimeout(10000);
        //DoOutputǷhttpUrlConnectionDoInputǷhttpUrlConnection룬ⷢpost
        //Ƿɶȡ
        connection.setDoOutput(true);
        connection.setDoInput(true);
        //ͨõ
        connection.setRequestProperty("accept", "*/*");
        connection.setRequestProperty("connection", "Keep-Alive");
        connection.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
        connection.setRequestProperty("Content-Type", "application/json;charset=utf-8");
        //ƴװ
        if (null != param && !param.equals("")) {
            //ò
            os = connection.getOutputStream();
            //ƴװ
            os.write(param.getBytes("UTF-8"));
        }
        //Ȩ
        //ͷ
        //
        //connection.connect();
        //ȡӦ
        if (connection.getResponseCode() == 200) {
            is = connection.getInputStream();
            if (null != is) {
                br = new BufferedReader(new InputStreamReader(is, "UTF-8"));
                String temp = null;
                while (null != (temp = br.readLine())) {
                    result.append(temp);
                    result.append("\r\n");
                }
            }
        }
        //ر
        connection.disconnect();
        return result.toString();
    }
}
